OGRE: Ogre::v1::GL3PlusRenderBuffer Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::v1::GL3PlusRenderBuffer Class Reference

Renderbuffer surface. More...

`#include <OgreGL3PlusHardwarePixelBuffer.h>`

Inheritance diagram for Ogre::v1::GL3PlusRenderBuffer:
[legend]

## Public Types
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE, HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = 5, HBU_DYNAMIC_WRITE_ONLY = 6, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...

## Public Member Functions
| GL3PlusRenderBuffer (GLenum format, uint32 width, uint32 height, GLsizei numSamples)
| ~GL3PlusRenderBuffer ()
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required. More...
virtual void | bindToFramebuffer (GLenum attachment, uint32 zoffset)
| Bind surface to frame buffer. More...
void | blit (const HardwarePixelBufferSharedPtr &src)
| Convenience function that blits the entire source pixel buffer to this buffer. More...
virtual void | blit (const HardwarePixelBufferSharedPtr &src, const Box &srcBox, const Box &dstBox)
| Copies a box from another PixelBuffer to a region of the this PixelBuffer. More...
void | blitFromMemory (const PixelBox &src)
| Convenience function that blits a pixelbox from memory to the entire buffer. More...
void | blitFromMemory (const PixelBox &src, const Box &dstBox)
| Copies a region from normal memory to a region of this pixelbuffer. More...
void | blitToMemory (const Box &srcBox, const PixelBox &dst)
| Copies a region of this pixelbuffer to normal memory. More...
void | blitToMemory (const PixelBox &dst)
| Convenience function that blits this entire buffer to a pixelbox. More...
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one. More...
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one. More...
const PixelBox & | getCurrentLock ()
| Get the current locked region. More...
uint32 | getDepth () const
| Gets the depth of this buffer. More...
PixelFormat | getFormat () const
| Gets the native pixel format of this buffer. More...
GLenum | getGLFormat ()
uint32 | getHeight () const
| Gets the height of this buffer. More...
virtual void * | getRenderSystemData (void)
| An internal function that should be used only by a render system for internal use. More...
virtual RenderTexture * | getRenderTarget (size_t slice=0)
| Get a render target for this PixelBuffer, or a slice of it. More...
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes. More...
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created. More...
uint32 | getWidth () const
| Gets the width of this buffer. More...
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading. More...
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked. More...
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory. More...
virtual const PixelBox & | lock (const Box &lockBox, LockOptions options)
| Lock the buffer for (potentially) reading / writing. More...
void * | lock (LockOptions options)
| Make every lock method from HardwareBuffer available. More...
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing. More...
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Make every lock method from HardwareBuffer available. More...
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | readData (size_t offset, size_t length, void *pDest)
| Reads data from the buffer and places it in the memory pointed to by pDest. More...
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes. More...
virtual void | unlock (void)
| Releases the lock on this buffer. More...
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough. More...

## Detailed Description

Renderbuffer surface.

Needs FBO extension.

## Member Enumeration Documentation

## ◆ LockOptions

enum Ogre::v1::HardwareBuffer::LockOptions
| inherited

Locking options.

Enumerator
HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved.
HBL_DISCARD | Discards the entire buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. Only allowed on buffers created with the HBU_DYNAMIC flag.
HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on static buffers, i.e. those created without the HBU_DYNAMIC flag.
HBL_NO_OVERWRITE | As HBL_DISCARD, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs.
HBL_WRITE_ONLY | Lock the buffer for writing only.

## ◆ Usage

enum Ogre::v1::HardwareBuffer::Usage
| inherited

Enums describing buffer usage; not mutually exclusive.

Enumerator
HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory.
HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used.
HBU_DISCARDABLE | Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated. This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.
HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY.
HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.

## Constructor & Destructor Documentation

## ◆ GL3PlusRenderBuffer()

Ogre::v1::GL3PlusRenderBuffer::GL3PlusRenderBuffer | ( | GLenum | format,
|  | uint32 | width,
|  | uint32 | height,
|  | GLsizei | numSamples
| ) |  |

## ◆ ~GL3PlusRenderBuffer()

Ogre::v1::GL3PlusRenderBuffer::~GL3PlusRenderBuffer | ( |  | ) |

## Member Function Documentation

## ◆ _updateFromShadow()

virtual void Ogre::v1::HardwareBuffer::_updateFromShadow | ( | void |  | ) |
| inlinevirtualinherited

Updates the real buffer from the shadow buffer, if required.

Reimplemented in Ogre::v1::MetalHardwareVertexBuffer, Ogre::v1::MetalHardwareIndexBuffer, Ogre::v1::GL3PlusHardwareVertexBuffer, Ogre::v1::GL3PlusHardwareIndexBuffer, and Ogre::v1::D3D11HardwareBuffer.

## ◆ bindToFramebuffer()

virtual void Ogre::v1::GL3PlusRenderBuffer::bindToFramebuffer | ( | GLenum | attachment,
|  | uint32 | zoffset
| ) |  |
| virtual

Bind surface to frame buffer.

Needs FBO extension.

Reimplemented from Ogre::v1::GL3PlusHardwarePixelBuffer.

## ◆ blit() [1/2]

void Ogre::v1::HardwarePixelBuffer::blit | ( | const HardwarePixelBufferSharedPtr & | src | ) |
| inherited

Convenience function that blits the entire source pixel buffer to this buffer.

If source and destination dimensions don't match, scaling is done.

Parameters

  src | PixelBox containing the source pixels and format in memory

Note
  Only call this function when the buffer is unlocked.

## ◆ blit() [2/2]

virtual void Ogre::v1::HardwarePixelBuffer::blit | ( | const HardwarePixelBufferSharedPtr & | src,
|  | const Box & | srcBox,
|  | const Box & | dstBox
| ) |  |
| virtualinherited

Copies a box from another PixelBuffer to a region of the this PixelBuffer.

Parameters

  src | Source pixel buffer
  srcBox | Box describing the source region in src
  dstBox | Box describing the destination region in this buffer

Remarks
  The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions.

Note
  Only call this function when both buffers are unlocked.

Reimplemented in Ogre::v1::MetalTextureBuffer, Ogre::v1::GLES2TextureBuffer, Ogre::v1::GL3PlusTextureBuffer, and Ogre::v1::D3D11HardwarePixelBuffer.

## ◆ blitFromMemory() [1/2]

void Ogre::v1::HardwarePixelBuffer::blitFromMemory | ( | const PixelBox & | src | ) |
| inlineinherited

Convenience function that blits a pixelbox from memory to the entire buffer.

The source image is scaled as needed.

Parameters

  src | PixelBox containing the source pixels and format in memory

Note
  Only call this function when the buffer is unlocked.

## ◆ blitFromMemory() [2/2]

void Ogre::v1::GL3PlusHardwarePixelBuffer::blitFromMemory | ( | const PixelBox & | src,
|  | const Box & | dstBox
| ) |  |
| virtualinherited

Copies a region from normal memory to a region of this pixelbuffer.

The source image can be in any pixel format supported by OGRE, and in any size.

Parameters

  src | PixelBox containing the source pixels and format in memory
  dstBox | Box describing the destination region in this buffer

Remarks
  The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions.

Note
  Only call this function when the buffer is unlocked.

Implements Ogre::v1::HardwarePixelBuffer.

Reimplemented in Ogre::v1::GL3PlusTextureBuffer.

## ◆ blitToMemory() [1/2]

void Ogre::v1::GL3PlusHardwarePixelBuffer::blitToMemory | ( | const Box & | srcBox,
|  | const PixelBox & | dst
| ) |  |
| virtualinherited

Copies a region of this pixelbuffer to normal memory.

Parameters

  srcBox | Box describing the source region of this buffer
  dst | PixelBox describing the destination pixels and format in memory

Remarks
  The source and destination regions don't have to match, in which case scaling is done.

Note
  Only call this function when the buffer is unlocked.

Implements Ogre::v1::HardwarePixelBuffer.

## ◆ blitToMemory() [2/2]

void Ogre::v1::HardwarePixelBuffer::blitToMemory | ( | const PixelBox & | dst | ) |
| inlineinherited

Convenience function that blits this entire buffer to a pixelbox.

The image is scaled as needed.

Parameters

  dst | PixelBox describing the destination pixels and format in memory

Note
  Only call this function when the buffer is unlocked.

## ◆ copyData() [1/2]

virtual void Ogre::v1::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer | ) |
| inlinevirtualinherited

Copy all data from another buffer into this one.

Remarks
  Normally these buffers should be of identical size, but if they're not, the routine will use the smallest of the two sizes.

References Ogre::v1::HardwareBuffer::getSizeInBytes(), and Ogre::min().

## ◆ copyData() [2/2]

virtual void Ogre::v1::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = `false`
| ) |  |
| inlinevirtualinherited

Copy data from another buffer into this one.

Remarks
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters

  srcBuffer | The buffer from which to read the copied data
  srcOffset | Offset in the source buffer at which to start reading
  dstOffset | Offset in the destination buffer to start writing
  length | Length of the data to copy, in bytes.
  discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Reimplemented in Ogre::v1::MetalHardwareVertexBuffer, Ogre::v1::MetalHardwareIndexBuffer, Ogre::v1::GLES2HardwareUniformBuffer, Ogre::v1::GL3PlusHardwareVertexBuffer, Ogre::v1::GL3PlusHardwareUniformBuffer, Ogre::v1::GL3PlusHardwareShaderStorageBuffer, Ogre::v1::GL3PlusHardwareIndexBuffer, Ogre::v1::GL3PlusHardwareCounterBuffer, Ogre::v1::D3D11HardwareVertexBuffer, Ogre::v1::D3D11HardwareUniformBuffer, Ogre::v1::D3D11HardwareIndexBuffer, and Ogre::v1::D3D11HardwareBuffer.

References Ogre::v1::HardwareBuffer::lock(), and Ogre::v1::HardwareBuffer::unlock().

## ◆ getCurrentLock()

const PixelBox& Ogre::v1::HardwarePixelBuffer::getCurrentLock | ( |  | ) |
| inherited

Get the current locked region.

This is the same value as returned by lock(const Box, LockOptions)

Returns
  PixelBox containing the locked region

## ◆ getDepth()

uint32 Ogre::v1::HardwarePixelBuffer::getDepth | ( |  | ) | const
| inlineinherited

Gets the depth of this buffer.

## ◆ getFormat()

PixelFormat Ogre::v1::HardwarePixelBuffer::getFormat | ( | void |  | ) | const
| inlineinherited

Gets the native pixel format of this buffer.

## ◆ getGLFormat()

GLenum Ogre::v1::GL3PlusHardwarePixelBuffer::getGLFormat | ( |  | ) |
| inlineinherited

## ◆ getHeight()

uint32 Ogre::v1::HardwarePixelBuffer::getHeight | ( |  | ) | const
| inlineinherited

Gets the height of this buffer.

## ◆ getRenderSystemData()

virtual void* Ogre::v1::HardwareBuffer::getRenderSystemData | ( | void |  | ) |
| inlinevirtualinherited

An internal function that should be used only by a render system for internal use.

Reimplemented in Ogre::v1::MetalHardwareVertexBuffer, and Ogre::v1::MetalHardwareIndexBuffer.

## ◆ getRenderTarget()

virtual RenderTexture* Ogre::v1::HardwarePixelBuffer::getRenderTarget | ( | size_t | slice = `0` | ) |
| virtualinherited

Get a render target for this PixelBuffer, or a slice of it.

The texture this was acquired from must have TU_RENDERTARGET set, otherwise it is possible to render to it and this method will throw an ERR_RENDERSYSTEM exception.

Parameters

  slice | Which slice

Returns
  A pointer to the render target. This pointer has the lifespan of this PixelBuffer.

Reimplemented in Ogre::v1::GL3PlusTextureBuffer, Ogre::v1::NULLHardwarePixelBuffer, Ogre::v1::D3D11HardwarePixelBuffer, Ogre::v1::MetalNullPixelBuffer, Ogre::v1::MetalDepthPixelBuffer, Ogre::v1::GLES2NullPixelBuffer, Ogre::v1::GLES2DepthPixelBuffer, Ogre::v1::GL3PlusNullPixelBuffer, Ogre::v1::GL3PlusDepthPixelBuffer, Ogre::v1::D3D11NullPixelBuffer, Ogre::v1::D3D11DepthPixelBuffer, Ogre::v1::MetalTextureBuffer, and Ogre::v1::GLES2TextureBuffer.

## ◆ getSizeInBytes()

size_t Ogre::v1::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const
| inlineinherited

Returns the size of this buffer in bytes.

Referenced by Ogre::v1::HardwareBuffer::copyData().

## ◆ getUsage()

Usage Ogre::v1::HardwareBuffer::getUsage | ( | void |  | ) | const
| inlineinherited

Returns the Usage flags with which this buffer was created.

## ◆ getWidth()

uint32 Ogre::v1::HardwarePixelBuffer::getWidth | ( |  | ) | const
| inlineinherited

Gets the width of this buffer.

## ◆ hasShadowBuffer()

bool Ogre::v1::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const
| inlineinherited

Returns whether this buffer has a system memory shadow for quicker reading.

## ◆ isLocked()

bool Ogre::v1::HardwareBuffer::isLocked | ( | void |  | ) | const
| inlineinherited

Returns whether or not this buffer is currently locked.

References Ogre::v1::HardwareBuffer::isLocked().

Referenced by Ogre::v1::HardwareBuffer::isLocked(), and Ogre::v1::HardwareBuffer::unlock().

## ◆ isSystemMemory()

bool Ogre::v1::HardwareBuffer::isSystemMemory | ( | void |  | ) | const
| inlineinherited

Returns whether this buffer is held in system memory.

## ◆ lock() [1/5]

virtual const PixelBox& Ogre::v1::HardwarePixelBuffer::lock | ( | const Box & | lockBox,
|  | LockOptions | options
| ) |  |
| virtualinherited

Lock the buffer for (potentially) reading / writing.

Parameters

  lockBox | Region of the buffer to lock
  options | Locking options

Returns
  PixelBox containing the locked region, the pitches and the pixel format

## ◆ lock() [2/5]

void* Ogre::v1::HardwareBuffer::lock
| inlineinherited

Make every lock method from HardwareBuffer available.

See http://www.research.att.com/~bs/bs_faq2.html#overloadderived

## ◆ lock() [3/5]

void* Ogre::v1::HardwareBuffer::lock | ( | LockOptions | options | ) |
| inlineinherited

Lock the entire buffer for (potentially) reading / writing.

Parameters

  options | Locking options

Returns
  Pointer to the locked memory

## ◆ lock() [4/5]

virtual void* Ogre::v1::HardwareBuffer::lock
| inlineinherited

Make every lock method from HardwareBuffer available.

See http://www.research.att.com/~bs/bs_faq2.html#overloadderived

References Ogre::Exception::ERR_INVALIDPARAMS, Ogre::v1::HardwareBuffer::lock(), and OGRE_EXCEPT.

## ◆ lock() [5/5]

virtual void* Ogre::v1::HardwarePixelBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) |  |
| virtualinherited

Lock the buffer for (potentially) reading / writing.

Parameters

  offset | The byte offset from the start of the buffer to lock
  length | The size of the area to lock, in bytes
  options | Locking options

Returns
  Pointer to the locked memory

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ readData()

virtual void Ogre::v1::HardwarePixelBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest
| ) |  |
| virtualinherited

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters

  offset | The byte offset from the start of the buffer to read
  length | The size of the area to read, in bytes
  pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::v1::HardwareBuffer.

## ◆ suppressHardwareUpdate()

void Ogre::v1::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) |
| inlineinherited

Pass true to suppress hardware upload of shadow buffer changes.

## ◆ unlock()

virtual void Ogre::v1::HardwareBuffer::unlock | ( | void |  | ) |
| inlinevirtualinherited

Releases the lock on this buffer.

Remarks
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented in Ogre::v1::GLES2DefaultHardwareUniformBuffer, Ogre::v1::GLES2DefaultHardwareIndexBuffer, Ogre::v1::GLES2DefaultHardwareVertexBuffer, Ogre::v1::GL3PlusDefaultHardwareCounterBuffer, Ogre::v1::GL3PlusDefaultHardwareUniformBuffer, Ogre::v1::GL3PlusDefaultHardwareIndexBuffer, Ogre::v1::GL3PlusDefaultHardwareVertexBuffer, Ogre::v1::D3D11HardwareVertexBuffer, Ogre::v1::D3D11HardwareUniformBuffer, Ogre::v1::D3D11HardwareIndexBuffer, Ogre::v1::DefaultHardwareCounterBuffer, Ogre::v1::DefaultHardwareUniformBuffer, Ogre::v1::DefaultHardwareIndexBuffer, and Ogre::v1::DefaultHardwareVertexBuffer.

References Ogre::v1::HardwareBuffer::isLocked(), and Ogre::v1::HardwareBuffer::unlock().

Referenced by Ogre::v1::HardwareBuffer::copyData(), Ogre::v1::HardwareBufferLockGuard::unlock(), and Ogre::v1::HardwareBuffer::unlock().

## ◆ writeData()

virtual void Ogre::v1::HardwarePixelBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = `false`
| ) |  |
| virtualinherited

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters

  offset | The byte offset from the start of the buffer to start writing
  length | The size of the data to write to, in bytes
  pSource | The source of the data to be written
  discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::v1::HardwareBuffer.

The documentation for this class was generated from the following file:

- OgreGL3PlusHardwarePixelBuffer.h